<template>
  <div class="gris">
    <div>
      <v-row>
        <v-col :cols="6" :sm="6">
          <v-row>
            <v-col>
              <strong>Certificador: </strong>{{ this.visita.nombre_empleado }}{{ this.visita.nombre_usuario }}
            </v-col>
            <v-col>
              <strong>Fecha:</strong> {{ this.visita.fecha_visita }}
            </v-col>
          </v-row>
          <v-row>
            <v-col>
              <v-select
                label="Protocolo"
                v-model="protocoloSelectedItem"
                :items="listaProtocolosUltVisita"
                item-value="id_protocolo"
                item-text="nombre_protocolo"
                @change="showRespuestasProtocolos"
                :value="protocoloSelected"
                return-object
              ></v-select>
            </v-col>
            <v-col>
              <div style="display: inline-block; float: left">
                <strong style="vertical-align: top">
                  Calificación del protocolo:
                  {{ this.calificacionProtocolo.calificacion }}
                </strong>
                <span
                  class="circulo"
                  v-bind:style="{
                    background: this.calificacionProtocolo.rango_color,
                  }"
                ></span>
              </div>
            </v-col>
          </v-row>
        </v-col>
        <v-col :cols="6" :sm="6">
          <v-row v-if="isReportesAcceso">
            <v-col>
              <v-btn @click="descargaReporte(1)">
                Descargar Reporte de revisión en sitio
              </v-btn>
            </v-col>
            <v-col>
              <v-btn @click="descargaReporte(2)"
                >Descargar Retroalimentación 7s
              </v-btn>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </div>
    <v-data-table
      :headers="headers"
      :items="items"
      :page.sync="page"
      :items-per-page="itemsPerPage"
      hide-default-footer
      @page-count="pageCount = $event"
      :search="search"
      class="tabla"
    >
      <template v-slot:item="row">
        <tr>
          <td align="left">
            {{ row.item.descripcion_pregunta }}
          </td>
          <td align="center">
            {{ row.item.respuesta }}
          </td>
          <td align="center">
            {{ row.item.ponderacion }}
          </td>

          <td align="center">
            <a
              v-if="row.item.evidencias.length > 0"
              class="liga"
              @click="verEvidencias(row.item)"
              block
              style="color: #2d2926"
              >Visualizar evidencia</a
            >
            <span v-else> No aplica </span>
          </td>

        </tr>
      </template>
    </v-data-table>
    <div class="text-center pt-2">
      <v-pagination
        v-model="page"
        :length="pageCount"
        class="paginador"
      ></v-pagination>
    </div>

    <v-dialog v-model="dialogEvidencia" :height="800" :width="800">
      <v-carousel v-model="model" height="auto">
        <v-carousel-item
          v-for="(evidencia, i) in respuesta.evidencias"
          :key="i"
        >
          <v-sheet>
            <v-card>
              <v-toolbar dense color="elevation-0">
                <v-spacer></v-spacer>
                <v-btn icon color="white" @click="dialogEvidencia = false">
                  <v-icon>mdi-close</v-icon>
                </v-btn>
              </v-toolbar>
              <v-row no-gutters>
                <v-col cols="12">
                  <v-row no-gutters align="center" justify="center">
                    <img
                      :src="evidencia.src"
                      :height="800"
                      :width="800"
                      contain
                    >
                  </v-row>
                </v-col>
              </v-row>
            </v-card>
          </v-sheet>
        </v-carousel-item>
      </v-carousel>
    </v-dialog>
  </div>
</template>
<style scoped>
.circulo {
  width: 20px;
  height: 20px;
  border-radius: 50%;
  display: inline-block;
}
.columna {
  height: 50px;
}
</style>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "TablaPuntoVentaUltCert",
  props: {
    listaProtocolosUltVisita: Array,
    visita: Object,
  },
  data() {
    return {
      nombre_protocolo: "",
      fecha_visita: "",
      id_ceco: "",
      nombre_ceco: "",
      model: 0,
      dialogEvidencia: false,
      items: [],
      evidencias: [],
      respuesta: {},
      page: 1,
      pageCount: 1,
      itemsPerPage: 10,
      search: "",
      protocoloSelectedItem: null,
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
      },
      isReportesAcceso:false,
      calificacionProtocolo: {},
      headers: [
        {
          text: "Pregunta",
          value: "descripcion_pregunta",
          align: "center",
        },
        {
          text: "Respuesta",
          value: "respuesta",
          align: "center",
        },
        {
          text: "Valor",
          value: "ponderacion",
          align: "center",
        },
        {
          text: "Evidencia",
          value: "evidencia",
          align: "center",
        },
      ],
    };
  },
  created() {},
  mounted() {},
  computed: {
    protocoloSelected() {
      if (this.protocoloSelectedItem === null) {
        if (this.listaProtocolosUltVisita.length > 0) {
          this.getPerfilesReportesAutorizados();
          this.asignaProtocoloSelected();
          this.setCalificacionProtocolo();
          this.getRespuestasProtocolo();
          return this.protocoloSelectedItem;
        } else {
          return {};
        }
      } else {
        return this.protocoloSelectedItem;
      }
    },
  },
  methods: {

    descargaReporte(valor) {
      const self = this;
      let url =
        "/franquicia/dashboard/punto/venta/secure/grafico/get/informe/certificacion/?" +
        "idCeco=" +
        this.visita.id_ceco +
        "&fecha=" +
        this.visita.fecha_visita;

      let axiosConfig = {
        headers: {
          "content-type": "application/x-www-form-urlencoded;charset=utf-8",
        },
      };

      axios
        .get(url, {
          headers: {
            "Content-Type": "application/json;charset=UTF-8",
          },
          data: {}, // envío un cuerpo (aunque sea un objeto vacío)
        })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data[0];
              let ipDesa = "http://10.53.33.82";
              if (data) {
                if (valor == 1) {
                  let rutaInforme = data.ruta_informe_general;

                  if (rutaInforme) {
                    window.open(ipDesa + rutaInforme);
                  }
                } else if (valor == 2) {
                  let rutaInforme = data.ruta_retro;

                  if (rutaInforme) {
                    window.open(ipDesa + rutaInforme);
                  }
                }
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    getPerfilesReportesAutorizados() {
      const self = this;
      axios
        .get("franquicia/dashboard/secure/parametro/perfilesReportes")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                if (data.valor) {
                  let perfiles = data.valor.split(",");
                  if (perfiles) {
                    self.isReportesAutorizados(perfiles);
                  }
                }
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    isReportesAutorizados(perfiles){
      const self = this
      store.state.perfiles.forEach((item) => {
        perfiles.forEach((perfil) => {
          if (item.perfil.id_perfil == perfil) {
            self.isReportesAcceso = true;
          }
        });
      });
    },

    setCalificacionProtocolo() {
      const self = this;
      this.listaProtocolosUltVisita.forEach((protocolo) => {
        if (
          protocolo.id_protocolo === self.protocoloSelectedItem.id_protocolo
        ) {
          self.calificacionProtocolo.calificacion =
            protocolo.calificacion_protocolo;
          self.calificacionProtocolo.rango_color = protocolo.rango_color;
        }
      });
    },

    asignaProtocoloSelected() {
      if (this.listaProtocolosUltVisita.length > 0) {
        this.protocoloSelectedItem = this.listaProtocolosUltVisita[0];
      }
    },

    showRespuestasProtocolos() {
      this.items = [];
      this.evidencias = [];
      this.setCalificacionProtocolo();
      this.getRespuestasProtocolo();
    },

    getRespuestasProtocolo() {
      const self = this;
      let url =
        "/franquicia/dashboard/punto/venta/secure/grafico/get/respuesta/certificacion/?" +
        "idCecoBase=" +
        this.protocoloSelectedItem.id_ceco_base +
        "&fecha=" +
        this.visita.fecha_visita +
        "&protocolo=" +
        this.protocoloSelectedItem.id_protocolo;

      let axiosConfig = {
        headers: {
          "content-type": "application/x-www-form-urlencoded;charset=utf-8",
        },
      };

      axios
        .get(url, {
          headers: {
            "Content-Type": "application/json;charset=UTF-8",
          },
          data: {}, // envío un cuerpo (aunque sea un objeto vacío)
        })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                //self.items = data;
                data.forEach((respuesta) => {
                  respuesta.evidencias = [];
                });
                self.getEvidencias(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    getEvidencias(respuestas) {
      const self = this;
      let url =
        "/franquicia/dashboard/punto/venta/secure/grafico/get/evidencia/?" +
        "idCecoBase=" +
        this.protocoloSelectedItem.id_ceco_base +
        "&fecha=" +
        this.visita.fecha_visita +
        "&protocolo=" +
        this.protocoloSelectedItem.id_protocolo;
      axios
        .get(url)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.evidencias = data;
                respuestas.forEach((respuesta) => {
                  respuesta.evidencias = self.getEvidenciaByPregunta(
                    respuesta.id_respuesta
                  );
                });
                self.items = respuestas;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    getEvidenciaByPregunta(id_respuesta) {
      let evidenciasArray = [];
      this.evidencias.forEach((evidencia) => {
        if (evidencia.id_respuesta === id_respuesta) {
          evidenciasArray.push(evidencia);
        }
      });
      return evidenciasArray;
    },

    verEvidencias(respuesta) {
      this.nombre_protocolo = this.protocoloSelectedItem.nombre_protocolo;
      this.id_ceco = this.visita.id_ceco;
      this.nombre_ceco = this.visita.nombre_ceco;
      this.respuesta = respuesta;
      this.respuesta.evidencias.forEach((evidencia) => {
        evidencia.src = "http://10.53.33.82" + evidencia.ruta_evidencia;
        //evidencia.src  = "http://10.53.33.82/franquicia/imagenes/2020/722878_12247492_30526_20200921172657.jpg"; //PENDIENTE
      });
      this.dialogEvidencia = true;
    },
  },
};
</script>
